<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px" @submit.native.prevent>
      <el-form-item label="名称" prop="name">
        <el-input
          v-model="queryParams.name"
          placeholder="请输入名称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="类型" prop="categoryType">
        <el-select v-model="queryParams.categoryType" placeholder="请选择类型" clearable size="small">
          <el-option
            v-for="dict in dict.type.cms_category_type"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item>
	    <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['business:cmsCategory:add']"
        >新增</el-button>
      </el-col>
        <el-col :span="1.5">
            <el-button
                    type="info"
                    plain
                    icon="el-icon-sort"
                    size="mini"
                    @click="toggleExpandAll"
            >展开/折叠</el-button>
        </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table
      v-if="refreshTable"
      v-loading="loading"
      :data="cmsCategoryList"
      row-key="categoryId"
      :default-expand-all="isExpandAll"
      :tree-props="{children: 'children', hasChildren: 'hasChildren'}"
    >
      <el-table-column label="名称" align="left" prop="name" width="200"/>
      <el-table-column label="编号" align="center" prop="categoryId" width="120"/>
      <el-table-column label="自定义链接" align="left" prop="diyUrl" />
      <el-table-column label="类型" align="center" prop="categoryType" width="150">
        <template slot-scope="scope">
          <dict-tag :options="dict.type.cms_category_type" :value="scope.row.categoryType"/>
        </template>
      </el-table-column>
      <el-table-column label="序号" align="center" prop="orderNum" width="150"/>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width" width="200">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['business:cmsCategory:edit']"
          >修改</el-button>
          <el-button
            v-if="scope.row.parentId == 0 || !scope.row.parentId"
            size="mini"
            type="text"
            icon="el-icon-plus"
            @click="handleAdd(scope.row)"
            v-hasPermi="['business:cmsCategory:add']"
          >新增</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['business:cmsCategory:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <!-- 添加或修改信息分类对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="800px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="120px">
        <el-form-item label="上级分类" prop="parentId">
          <el-select v-model="form.parentId"  placeholder="请选择" @change="$forceUpdate()" clearable>
            <el-option
              v-for="item in cmsCategoryOptions"
              :key="item.categoryId"
              :label="item.name"
              :value="item.categoryId"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="名称" prop="name">
          <el-input v-model="form.name" placeholder="请输入名称" />
        </el-form-item>
        <el-form-item label="类型">
          <el-radio-group v-model="form.categoryType">
            <el-radio
              v-for="dict in dict.type.cms_category_type"
              :key="dict.value"
              :label="parseInt(dict.value)"
            >{{dict.label}}</el-radio>
          </el-radio-group>
        </el-form-item>
        <el-form-item label="自定义链接" prop="diyUrl">
          <el-input v-model="form.diyUrl" placeholder="请输入自定义链接" />
        </el-form-item>
    <el-form-item label="序号" prop="orderNum">
        <el-input-number v-model="form.orderNum" controls-position="right"   :min="0" placeholder="请输入序号" />
    </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" type="textarea" placeholder="请输入内容" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listCmsCategory, getCmsCategory, delCmsCategory, addCmsCategory, updateCmsCategory, listParentCmsCategory } from "@/api/business/cmsCategory";

export default {
  name: "CmsCategory",
  dicts: ['cms_category_type'],
  components: {

  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 显示搜索条件
      showSearch: true,
      // 信息分类表格数据
      cmsCategoryList: [],
      // 信息分类树选项
      cmsCategoryOptions: [],
      // 弹出层标题
      title: "",
      // 是否展开，默认全部展开
      isExpandAll: true,
      // 重新渲染表格状态
      refreshTable: true,
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        name: null,
        categoryType: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        name: [
          { required: true, message: "名称不能为空", trigger: "blur" }
        ],
        categoryType: [
          { required: true, message: "类型不能为空", trigger: "blur" }
        ],
      }
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询信息分类列表 */
    getList() {
      this.loading = true;
      listCmsCategory(this.queryParams).then(response => {
        this.cmsCategoryList = this.handleTree(response.data, "categoryId", "parentId");
        this.loading = false;
      });
    },

    getCmsCategorySelect(){
      listParentCmsCategory().then(res => {
        this.cmsCategoryOptions = res.data
      })
    },

    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        categoryId: null,
        parentId: null,
        ancestors: null,
        name: null,
        categoryType: 0,
        diyUrl: null,
        orderNum: null,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null,
        remark: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 新增按钮操作 */
    handleAdd(row) {
      this.reset();
      this.getCmsCategorySelect();
      if (row != null && row.categoryId) {
        this.form.parentId = row.categoryId;
      } else {
        this.form.parentId = null;
      }
      this.open = true;
      this.title = "添加信息分类";
    },
    /** 展开/折叠操作 */
    toggleExpandAll() {
      this.refreshTable = false;
      this.isExpandAll = !this.isExpandAll;
      this.$nextTick(() => {
          this.refreshTable = true;
      });
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      this.getCmsCategorySelect();
      getCmsCategory(row.categoryId).then(response => {
        this.form = response.data;
        if (this.form.parentId == 0){
          this.form.parentId = null;
        }
        this.open = true;
        this.title = "修改信息分类";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.categoryId != null) {
            updateCmsCategory(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addCmsCategory(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      this.$modal.confirm('是否确认删除信息分类名称为"' + row.name + '"的数据项？').then(function() {
        return delCmsCategory(row.categoryId);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    }
  }
};
</script>
